%define	homedir         /var/tomcat
%define javalibdir      /usr/share/java

# RH 7.0
#%%define manualdir		/var/www/html/manual/%{name}
# RH 6.x
%define manualdir		/home/httpd/html/manual/%{name}

%define confdir  		%{homedir}/conf
%define appdir   		%{homedir}/webapps
%define workdir	  		%{homedir}/work
%define logdir   		%{homedir}/logs
%define libdir   		%{homedir}/lib
%define bindir   		/usr/bin
%define packname 		jakarta-tomcat-%{version}-src
%define spackname 		jakarta-servletapi-3.2-src

Summary: 		Apache's servlet engine
Name: 			tomcat
Version: 		3.2.1
Release: 		1
Vendor: 		Apache Software Foundation
Group: 			Networking/Daemons
Copyright: 		Apache
Url: 			http://jakarta.apache.org
Provides: 		tomcat 
BuildArch: 		noarch
BuildRequires: 	ant >= 1.1
Source: 		http://jakarta.apache.org/builds/tomcat/release/v%{version}/src/%{packname}.tar.gz
Source1: 		http://jakarta.apache.org/builds/tomcat/release/v%{version}/src/%{spackname}.tar.gz
Source3: 		TOMCAT.README.RPM
Source4: 		tomcat.init
Source5: 		tomcat.logrotate
Patch: 			tomcat-3.2.1.patch
Packager: 		Henri Gomez <hgomez@slib.fr>
BuildRoot: 		/var/tmp/%{name}-root

%description
Develop Web applications in Java.

%package manual
Group: 		Documentation
Requires: 	webserver
Summary: 	Online manual for tomcat
Obsoletes:	tomcat-doc

%description manual
Documentation for tomcat.

%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}

%setup -c -T -a 0
%setup -T -D -a 1
%patch

%build
export TCRPMDIR=$RPM_BUILD_DIR/%{name}-%{version}
export CLASSPATH=$JAVA_HOME/lib/tools.jar:$CLASSPATH

if [ -f /usr/bin/jikes ]; then
	export ANTJIKES=-Dbuild.compiler=jikes
fi

# servlet-api
cd %{spackname}
ant $ANTJIKES clean
ant $ANTJIKES dist

# tomcat
cd ../%{packname}
export CLASSPATH=$TCRPMDIR/dist/servletapi/lib/servlet.jar:$TCRPMDIR/jakarta-tools/moo.jar:$TCRPMDIR/build/tomcat/classes:$JAVA_HOME/lib/tools.jar:$JAVA_HOME/lib/dev.jar:$CLASSPATH
ant $ANTJIKES -Dant.home=/usr/share/ant -Djavalib.home=%{javalibdir} -Djaxp=%{javalibdir} -Dservlet.jar=$TCRPMDIR/dist/servletapi/lib/servlet.jar dist

%install
mkdir -p $RPM_BUILD_ROOT%{bindir}
mkdir -p $RPM_BUILD_ROOT%{confdir}
mkdir -p $RPM_BUILD_ROOT%{appdir}
mkdir -p $RPM_BUILD_ROOT%{workdir}
mkdir -p $RPM_BUILD_ROOT%{libdir}
mkdir -p $RPM_BUILD_ROOT%{logdir}
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/usr/bin
# doc is now installed in BUILD_DIR
mkdir -p $RPM_BUILD_ROOT%{manualdir}/tomcat
mkdir -p $RPM_BUILD_ROOT%{manualdir}/servletapi

cp -rf  dist/servletapi/docs/api/*  $RPM_BUILD_ROOT%{manualdir}/servletapi	
cp -rf  dist/tomcat/doc/*      	  	$RPM_BUILD_ROOT%{manualdir}/tomcat
cp -rf  dist/tomcat/lib/*     	  	$RPM_BUILD_ROOT%{libdir}
cp -f   /usr/share/java/ant.jar   	$RPM_BUILD_ROOT%{libdir}
cp -f   /usr/share/java/jaxp.jar    $RPM_BUILD_ROOT%{libdir}
cp -f   /usr/share/java/parser.jar  $RPM_BUILD_ROOT%{libdir}
install dist/tomcat/conf/*    	  	$RPM_BUILD_ROOT%{confdir}
install dist/tomcat/webapps/* 	  	$RPM_BUILD_ROOT%{appdir}
install dist/tomcat/bin/jspc.sh   	$RPM_BUILD_ROOT%{bindir}/jspc
install dist/tomcat/bin/tomcat.sh 	$RPM_BUILD_ROOT/usr/bin/tomcat

# sysv init and logging
install %{SOURCE3} .
install %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d/tomcat
install %{SOURCE5} $RPM_BUILD_ROOT%{confdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo ""
echo ""
echo "Don't forget to set JAVA_HOME in /etc/rc.d/init.d/tomcat"
echo "to your JDK/JRE directory since we didn't have these info"
echo "at boot time."
echo "As supplied we assume you're using IBM JDK 1.3.0"
echo ""

/sbin/chkconfig --add tomcat

%preun
if [ $1 = 0 ]; then
 
    if [ -f /var/lock/subsys/tomcat ]; then
        /etc/rc.d/init.d/tomcat stop
    fi
    if [ -f /etc/rc.d/init.d/tomcat ]; then
        /sbin/chkconfig --del tomcat
    fi
fi

%files
%defattr(644 root root 755)
%attr(755,root,root)      %dir 				 	%{libdir}
%attr(755,root,root)      %dir 				 	%{bindir}
%attr(755,root,root)      %dir 				 	%{confdir}
%attr(755,root,root)  	  %dir 				 	%{appdir}
%attr(755,nobody,nobody)  %dir 			 		%{workdir}
%attr(755,nobody,nobody)  %dir 			 		%{logdir}
%attr( - ,root,root)       					 	%{bindir}/*
%attr( - ,root,root) 	  %config(noreplace) 	%{confdir}/*
%attr(755,root,root)  	  %config 		 		/etc/rc.d/init.d/*
%attr( - ,root,root)       				 		%{libdir}/*
%attr(644,root,root)       				 		%{appdir}/*
%attr( - ,root,root)  	  %doc 			 		TOMCAT.README.RPM dist/tomcat/doc/* %{packname}/{LICENSE,README,RELE*,TODO}

%files manual
%defattr(644 root root 755)
%attr( - ,root,root)							%{manualdir}


%changelog
* Thu Dec 14 2000 Henri Gomez <hgomez@slib.fr>
- v3.2.1 release
- added Dan Milstein patch (Multipart stream error on ajp13)

* Tue Dec 12 2000 Henri Gomez <hgomez@slib.fr>
- v3.2 RPM release 2
- grab some fixes from upcoming 3.2.1
- modified tomcat script to use /var/log/tomcat.log in start mode

* Fri Nov 30 2000 Henri Gomez <hgomez@slib.fr>
- v3.2 official release
- at least, it's arrived, it's there
- on RPM side, new tomcat.init, updated TOMCAT.README.RPM
- RequestDispatcher patch removed since included now in distro

* Fri Nov 24 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-8 RPM release 4 
- Fixed the ajp13 bug (with RequestDispatcher)

* Wed Nov 22 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-8 RPM release 3
- removed the secure parameter in server.xml and added comment about keystore, keypass, clientAuth
- updated TOMCAT.README.RPM with SSL informations.
- rebuilded with jsse (1.0.2), IBM JDK 1.3.0 (cx130-20001025), jikes 1.12
- build CLASSPATH=/usr/share/java/jsse.jar:/usr/share/java/jcert.jar:/usr/share/java/jnet.jar

* Tue Nov 21 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-8 RPM release 2
- missed to include servlet.jar (hey boy check build.xml)

* Tue Nov 21 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-8 RPM
- removed ajp13 & ContextManager patch (included in distro)
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5, ant 1.2, jikes 1.12

* Tue Nov 14 2000 Henri Gomez <hgomez@slib.fr>
- RPM Release 2
- corrected ajp13 post > 8k <hgomez@slib.fr>
- corrected ContextManager <marc.saegesser@apropos.com>
- corrected workers.properties and mod_jk.conf (tomcat home is /var/tomcat)

* Mon Nov 13 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-7 RPM
- build CLASSPATH=$CLASSPATH:/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar

* Tue Oct 24 2000 Henri Gomez <hgomez@slib.fr>
- RPM Release 4
- renamed tomcat-doc to tomcat-manual (follow apache RPM naming)
- RH 7.0 changes location of docdir and DocumentRoot. The spec file is modified
  to place manual in right place when rebuilded under RH 6.x or RH 7.0
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5

* Tue Oct 17 2000 Henri Gomez <hgomez@slib.fr>
- RPM Release 3
- follow Debian policy about java stuff, libs in /usr/share/java,
  executable in /usr/bin
- prepare transition to RH 7.0 new document root (/var/www)

* Thu Oct 12 2000 Henri Gomez <hgomez@slib.fr>
- RPM release 2
- correct webapps file mod (644)
- correct server.xml with secure param set for SSL

* Thu Oct 12 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-6 RPM
- removed ajp12 patch (now there are included)
- JSSE is now NEEDED to build Tomcat (like TC 4.0)
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar

* Fri Oct 06 2000 Henri Gomez <hgomez@slib.fr>
- RPM release 2
- tomcat is now installed on /home/tomcat instead of
  /opt/tomcat since /opt is mounted read-only on
  many systems <summer@os2.ami.com.au>
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar
- correct stuff in spec file (copyright, group...)

* Mon Sep 25 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-5 RPM
- detect jikes and use it to rebuild (yep 10 times faster).
- patched incorrect version number
- rebuilded with jikes 1.12 (and jsse 1.0.2).

* Thu Sep 14 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-4 RPM
- mainly documentations correction and WEB-INF/lib jars classloading

* Mon Sep 11 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3 RPM release 3
- updated TOMCAT.README.RPM (more info on mod_jk and mod_ssl)

* Fri Sep 08 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3 RPM release 2
- new release for my birthday ;-)
- removed apache-devel requirement (no APXS use here)
- rebuilded with jsse (1.0.2) and IBM JDK 1.3.0 (cx130-20000815)
- tomcat.init modified to use IBM JDK 1.3.0. 
- signed with my PGP key

* Fri Sep 01 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-3
- removed AJP13 patch (included now)

* Fri Jul 28 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-2 RPM release 1
- Added TOMCAT.README.RPM for information on how to rebuild RPM.
- Modified RPM to keep CLASSPATH in build.
- Rebuilt with jsse (1.0.1) jars in CLASSPATH to add SSL support to tomcat. 
- Removed JDK determination at post time
   
* Thu Jul 27 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-2
- Initial RPM for v3.2-beta-2 (modules are now in another RPM)
- Installation stay under /opt until tomcat add support alternate
  configuration separation.
- Rebuild rpm with IBM JDK 1.3 (cx130-20000623) to allow ant
  work under both JDK 1.1.8 and JDK 1.3.

* Wed Jul 19 2000 Henri Gomez <hgomez@slib.fr>
- v3.1-8
- corrected %post and %preun for jserv to also
  support standard Redhat 6.2 apache httpd.conf.

* Wed Jul 17 2000 John Summerfield <summer@os2.ami.com.au>
- v3.1-6
- Edit /etc/rc.d/init.d/tomcat so it picks up Java settings from user for java2 at install time
- Requires: ed, and some trickery. Sources bash init scripts to setup a typical users' environment
- Move webapps to /var - /usr must not be written (especially by users!)
- Change port 8007 to 8008 as the former is used (by default) by jserv.

* Wed Jul 5 2000 John Summerfield <summer@os2.ami.com.au>
- v3.1-6
- Edit /etc/rc.d/init.d/tomcat so it picks up Java settings from user (if set) at install time
- Requires: ed

* Sat Jun 24 2000 John Summerfield <summer@os2.ami.com.au>
- v3.1-5
- work directory must be owned by nobody so tomcat can write to it

* Sat Jun 24 2000 John Summerfield <summer@os2.ami.com.au>
- v3.1-4
- use %{prefix} to simplify configuration of where it's installed
- link logs to log directory for apache
- link tomcat/work to a directory in /var; /usr should be ro.

* Mon May 22 2000 Henri Gomez <hgomez@slib.fr>
- v3.1-3
- apply SSL patch (Ajp12ConnectionHandler.java)

* Thu May 04 2000 Henri Gomez <hgomez@slib.fr>
- v3.1-2
- Added JAVA_HOME to tomcat.init, necessary at init
  time to determine where is your JAVA_HOME
 
* Tue May 02 2000 Henri Gomez <hgomez@slib.fr>
- v3.1 final release
- Compiled on Redhat 6.1 with IBM JDK 1.1.8 (20000328)
  for apache 1.3.12 + mod_ssl 2.6.4 (EAPI support).

* Thu Apr 13 2000 Henri Gomez <hgomez@slib.fr>
- v3.1_rc1
- RPM didn't replace configuration files of tomcat in /opt/tomcat/conf 
  This choice is to avoid trashing your own settings. 
  Warning, since v3.1_rc1, you need to to set home vars in ContextManager 
  in file /opt/tomcat/conf/server.xml like this :
  <ContextManager debug="0" workDir="work" home="/opt/tomcat">
- New in v3.1_rc1 is that tomcat generate dynamically a conf file,
  tomcat-apache.conf, in /opt/tomcat/conf
- compiled on Redhat 6.1 with IBM JDK 1.1.8 (20000328)
  for apache 1.3.12 + mod_ssl 2.6.2 (EAPI support).

* Thu Mar 09 2000 Henri Gomez <gomez@slib.fr>
- v3.1b1-2
- added missing tomcat.init (oups)
- tomcat home is in /opt/tomcat but there is a link
  /usr/bin/tomcat to allow any user to start it since
  now it didn't use privilegied port (8007 & 8080).
  This may be an issue if you only want root start it.
- added logrotate support for apache/jserv side. 
  Will add tomcat log support when we could signal
  tomcat to rotate logs.
- compiled on Redhat 6.1 with IBM JDK 1.1.8 (19991220) 
  for apache 1.3.12 + mod_ssl 2.6.2 (EAPI support).

* Thu Mar 09 2000 Henri Gomez <gomez@slib.fr>
- v3.1b1-1
- compile and install mod_jserv for apache
  renamed to mod_jserv_tomcat.so to avoid conflict
  with mod_jserv.so from jserv 1.1 (java.apache.org)

* Wed Mar 08 2000 Henri Gomez <gomez@slib.fr>
- v3.1b1

* Tue Feb 29 2000 Henri Gomez <gomez@slib.fr>
- v3.1_m2rc2

* Fri Feb 25 2000 Henri Gomez <gomez@slib.fr>
- v3.1_m2rc1

* Fri Jan 28 2000 Henri Gomez <gomez@slib.fr>
- v3.1_m1

* Tue Jan 18 2000 Henri Gomez <gomez@slib.fr>
- first RPM of tomcat 3.1 m1_rc1

* Tue Jan  4 2000 Henri Gomez <gomez@slib.fr>
- moved from /opt/jakarta/jakarta-tomcat to /opt/tomcat

* Tue Jan  4 2000 Henri Gomez <gomez@slib.fr>
- CVS 4 Jan 2000

* Thu Dec 30 1999 Henri Gomez <gomez@slib.fr>
- Initial release for jakarta-tomcat cvs


